#line 1 "D:/PortMon/portmon.c"
char ssd_table[16] = {64, 121, 36, 48, 25, 18, 2, 120, 0, 16, 8, 3, 70, 33, 6, 14};
char input_main, linput, beep_counter;

void WriteSSD(char value) {
 char pos;
 P3_0_bit = 0;
 P3_1_bit = 0;
 P3_2_bit = 0;
 for(pos = 0; pos < 8; pos++) {
 Delay_us(5);
 P3_2_bit = (value >> pos) & 1;
 Delay_us(5);
 P3_0_bit = 1;
 Delay_us(10);
 P3_0_bit = 0;
 }
 P3_1_bit = 1;
 Delay_us(10);
 P3_1_bit = 0;
}

void ShowNumber(char num) {
 WriteSSD(ssd_table[(num & 15)]);
 P3_3_bit = 1;
 Delay_ms(5);
 P3_3_bit = 0;
 Delay_us(50);
 WriteSSD(ssd_table[(num >> 4)]);
 P3_4_bit = 1;
 Delay_ms(5);
 P3_4_bit = 0;
 Delay_us(50);
}

void main() {
 ACSR = 0;
 SCON = 0;
 P3 = 0;
 P1 = 255;
 linput = 0;
 input_main = 0;
 beep_counter = 4;

 while(1) {
 input_main = P1;
 ShowNumber(input_main);
 if(input_main != linput)
 beep_counter = 0;
 P3_5_bit = 0;
 if(beep_counter < 4) {
 P3_5_bit = 1;
 beep_counter++;
 }
 linput = input_main;
 }

}
